static  const char rcsid[] = "$Id: checkip.c,v 1.4 2004/05/05 05:08:34 dengxf Exp $";

/*
 * Copyright (c) 2003-2004 Deng XueFeng <dsnofe@hotmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by Deng XueFeng.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY DENG XUEFENG AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

unsigned int checkipnum(register char * const start, register char const * const end)
{
    register char *p;

    p = start;
    if ((start == end) || (end > start + 3)) {
        return (0);
    }
    while (p < end) {
        if ((*p < 0x30) || (*p > 0x39)) {
            return (0);
        }
        p++;
    }
    if (end - start == 3) {
        if (*start > 0x32) {
            return (0);
        } else if (*start == 0x32) {
            if (*(start + 1) > 0x35) {
                return (0);
            } else if ((*(start + 1) == 0x35) && (*(start + 2) > 0x35)) {
                return (0);
            }
        } else {
            return (1);
        }
    }
    return (1);
}

unsigned int isip(char *str)
{
    register unsigned int i;
    register char *start, *end;

    i = 0;
    start = str;
    while (i++ < 3) {
        end = start;
        while (*end != 0x00) {
            if (*end == 0x2E) {
                break;
            }
            end++;
        }
        if (*end == 0x00) {
            return (0);
        }
        if (checkipnum(start, end) == 0) {
            return (0);
        }
        start = ++end;
    }
    while (*end != 0x00) {
        end++;
    }
    if (checkipnum(start, end) == 0) {
        return (0);
    }
    return (1);
}

//
// ﱣ֤dst㹻Ŀռ IP.
// char dst[16]Ǳ.
//

unsigned int checkip(register char const *src, register char *dst)
{
    register unsigned int i, j, flag, sum;
    char *save;

    i = j = flag = sum = 0;
    save = dst;
    if ((src == 0x00) || (dst == 0x00)) {
        return (0);
    }
    while (*src) {
        if (++j > 15) {
            *dst = 0x00;
            return (0);
        }
        if (flag == 1) {
            *dst++ = *src;
        } else if ((*src != 0x30) || (*(src + 1) == 0x00) || (*(src + 1) == 0x2E)) {
            *dst++ = *src;
            flag = 1;
        }
        if (*src == 0x2E) {
            flag = 0;
            i++;
            sum = 0;
        } else {
            sum++;
            if (sum > 3) {
                *dst = 0x00;
                return (0);
            }
        }
        src++;
    }
    if (i > 3) {
        *dst = 0x00;
        return (0);
    }
    if (*(dst - 1) == 0x2E) {
        dst--;
        i--;
    }
    while (i++ < 3) {
        if (dst - save >= 14) {
            *dst = 0x00;
            return (0);
        }
        *dst++ = 0x2E;
        *dst++ = 0x30;
    }
    *dst = 0x00;
    if (isip(save) == 1) {
        return (1);
    }
    return (0);
}
