/*  $Id: pop3d.h,v 1.6 2004/05/05 05:08:35 dengxf Exp $    */

/*
 * Copyright (c) 2003-2004 Deng XueFeng <dsnofe@hotmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by Deng XueFeng.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY DENG XUEFENG AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#define DEF_UDB_INIT                0
#define DEF_UDB_FREEED              1
#define DEF_UDB_USED                2
#define DEF_UDB_FREEED_THEN_USED    3

#define DEF_CMDNAME_UNKNOWN         0
#define DEF_CMDNAME_USER            1
#define DEF_CMDNAME_PASS            2
#define DEF_CMDNAME_QUIT            3
#define DEF_CMDNAME_LIST            4
#define DEF_CMDNAME_UIDL            5
#define DEF_CMDNAME_DELE            6
#define DEF_CMDNAME_RETR            7
#define DEF_CMDNAME_STAT            8
#define DEF_CMDNAME_RSET            9
#define DEF_CMDNAME_NOOP            10
#define DEF_CMDNAME_EXIT            11

#define DEF_CACHE_DONE              1
#define DEF_CACHE_UNDONE            0

/* Mail info */
typedef struct {
    short int id;
    short int f_del;
    short int f_read;
    short int f_new;
    int       size;
    char      name[64];
} MINFO;

/* User Data Block */
typedef struct {
    short int free;
    short int welmsg;
    short int login;
    short int c_status;
    short int cmd;
    short int cmderr;
    short int curerrs;
    short int maxid;
    short int upid;
    short int ucsize;
    short int a_id;
    int       offset;
    char     *mail;
    char      username[16];
    char      maildir[64];
    MINFO    *c_all;
    MINFO   **c_updated;
} UDB;

/* Command structure */
typedef struct {
    char      name[5];
    char      value[41];
} CMDTBL;

void pop3d(void);
